---

# Notes:
# Sample project C code is not presently written to produce a release artifact.
# As such, release build options are disabled.
# This sample, therefore, only demonstrates running a collection of unit tests.

:project:
  :use_exceptions: FALSE
  :use_test_preprocessor: TRUE
  :use_auxiliary_dependencies: TRUE
  #build_root is where ceedling will put all temp files
  :build_root: build
  #:release_build: TRUE
  :test_file_prefix: test_
  :which_ceedling: gem
  :ceedling_version: 0.30.0
  :default_tasks:
    - test:all

#:test_build:
#  :use_assembly: TRUE

#:release_build:
#  :output: MyApp.out
#  :use_assembly: FALSE

:environment:

:extension:
  :executable: .out

#Paths that ceedling will use to find files
# +: files that will be added
# -: files that will be removed
:paths:
  :test:
    - +:test/**
    - -:test/support
  :source:
    - src/**
  :include:
    - include/**
  :support:
    - test/support
  :libraries: []

:defines:
  # in order to add common defines:
  #  1) remove the trailing [] from the :common: section
  #  2) add entries to the :common: section (e.g. :test: has TEST defined)
  :common: &common_defines []
  :test:
    - *common_defines
    - TEST
  :test_preprocess:
    - *common_defines
    - TEST

:cmock:
  :mock_prefix: mock_
  :when_no_prototypes: :warn
  :enforce_strict_ordering: TRUE
  :plugins:
    - :ignore
    - :callback
  :treat_as:
    uint8:    HEX8
    uint16:   HEX16
    uint32:   UINT32
    int8:     INT8
    bool:     UINT8

# Add -gcov to the plugins list to make sure of the gcov plugin
# You will need to have gcov and gcovr both installed to make it work.
# For more information on these options, see docs in plugins/gcov
:gcov:
  :reports:
    - HtmlDetailed
  :gcovr:
    :html_medium_threshold: 75
    :html_high_threshold: 90

# Ceedling defaults to using gcc for compiling, linking, etc.
# As [:tools] is blank, gcc will be used (so long as it's in your system path)
# See documentation to configure a given toolchain for use
#:tools:
#  :test_compiler:
#    :executable: gcc
#    :name: 'GCC Test Compiler'
#    #arguments is where command line arguments go
#    # ${1} contains the input/inputs to the step a compile step will replace with the name of the c file
#    # ${2} contains the ouput name of the step
#    # #{'cmd'} will execute a shell command before runninf the tool and put the result here
#    # "$": or $: expects a ceedling collective
#    :arguments:
#      - --verbose
#      - -I"$" : COLLECTION_PATHS_INCLUDE
#      - -Wall
#      - -O0
#      - -c ${1}
#      - -o ${2}  
  #:test_fixture:
  #  :executable: <path to simulator>
  #:test_linker:

  #:release_compiler:
  #:release_linker:

# LIBRARIES
# These libraries are automatically injected into the build process. Those specified as
# common will be used in all types of builds. Otherwise, libraries can be injected in just
# tests or releases. These options are MERGED with the options in supplemental yaml files.
:libraries:
  :placement: :end
  :flag: "-l${1}"
  :path_flag: "-L ${1}"
  :system: []    # for example, you might list 'm' to grab the math library
  :test: []
  :release: []

:plugins:
  :load_paths:
    - "#{Ceedling.load_path}"
  :enabled:
    - stdout_pretty_tests_report
    - module_generator

:module_generator:
  :project_root: ./
  :src_root: src/
  :inc_root: include/
  :tst_root: test/
  :boilerplates:
    :src: |
      //! \file
      //! \addtogroup <label>
      //! \author Luke Paulson
      //! \date 
      //! \copyright The MIT License (MIT)
      //! \version 
    :inc: |
      //! \file
      //! \addtogroup <lable>
      //! \brief
      //! \details 
      //! \author Luke Paulson
      //! \date 
      //! \copyright The MIT License (MIT) 
      //! \version
    :tst: |
      //! \file
      //! \brief
      //! \addtogroup TEST
      //! \author Luke Paulson
      //! \date 
      //! \copyright The MIT License (MIT)
      //! \version
...


